<section class="block feature-boxes-group" data-block="Feature Boxes" data-block-key="FEATURES" data-block-image="group_feature_boxes.png">
	{insertablegroup title="Feature Boxes" name="FEATURES" group="Feature Boxes" descriptor="Feature Box"}
		{insertable name="header"             type="text"     title="Header Text" group="Feature Boxes"}{/insertable}
		{insertable name="header_image"       type="file"     title="Header Image" browseable=1 accept="image/*" group="Feature Boxes"}{/insertable}
		{insertable name="header_text_color"  type="color"    title="Header Text Color" group="Feature Boxes"}{/insertable}
		{insertable name="header_bg_color"    type="color"    title="Header Background Color" group="Feature Boxes"}{/insertable}
		{insertable name="content"            type="textarea" title="Content" group="Feature Boxes"}{/insertable}
		{insertable name="content_side"       type="select"   title="Content Side" options="left|right" default="right" group="Feature Boxes"}{/insertable}
		{insertable name="content_text_color" type="color"    title="Content Text Color" group="Feature Boxes"}{/insertable}
		{insertable name="content_bg_color"   type="color"    title="Content Background Color" group="Feature Boxes"}{/insertable}
		{insertable name="box_link"           type="text"     title="Box Link" group="Feature Boxes"}{/insertable}
		{insertable name="box_size"           type="select"   title="Box Size" options="small|medium|full" default="small" group="Feature Boxes"}{/insertable}
	{/insertablegroup}

	<div class="width-wrapper">
		{foreach $FEATURES as $group}
			{assign var="box_class" value="feature-box track-click box-size-`$group.box_size` box-side-`$group.content_side`"}
			{assign var="box_style" value=""}
			{assign var="box_header_style" value=""}
			{assign var="box_content_style" value=""}

			{if $group.header || $group.header_image}
				{assign var="box_class" value="$box_class box-has-header"}
			{/if}
			{if $group.header_text_color}
				{assign var="box_header_style" value="$box_header_style color:`$group.header_text_color`;"}
			{/if}
			{if $group.header_bg_color}
				{assign var="box_header_style" value="$box_header_style background-color:`$group.header_bg_color`;"}
			{/if}
			{if $group.content_text_color}
				{assign var="box_content_style" value="$box_content_style color:`$group.content_text_color`;"}
			{/if}
			{if $group.content_bg_color}
				{assign var="box_style" value="$box_style background-color:`$group.content_bg_color`;"}
			{/if}
			{if $group.box_link}
				{assign var="box_class" value="$box_class box-has-link"}
			{/if}


			{if $page}
				{assign var=tag value="`$page.title|str_to_id`/`$group.header|str_to_id`"}
			{else}
				{assign var=tag value="`$group.header|str_to_id`"}
			{/if}

			<article class="{$box_class}" style="{$box_style}" data-track-category="{$tag}" data-track-action="FeatureBox">
				{if $group.header || $group.header_image}
					<h2 class="feature-box-header" style="{$box_header_style}">
						{if $group.box_link}
							{a href="`$group.box_link`"}
								<span>{$group.header}</span>
								{if $group.header_image}
									{img src="`$group.header_image`"}
								{/if}
							{/a}
						{else}
							<span>{$group.header}</span>
							{if $group.header_image}
								{img src="`$group.header_image`"}
							{/if}
						{/if}
					</h2>
				{/if}

				<div class="feature-box-content" style="{$box_content_style}">
					{if $group.box_link}
						{a href="`$group.box_link`"}
						{$group.content|md_to_html}
						{/a}
					{else}
						{$group.content|md_to_html}
					{/if}
				</div>
			</article>
		{/foreach}
	</div>
</section>