<ul class="listing-collection files" data-block="Files Group" data-block-key="FILES" data-block-image="group_files.svg">
    {insertablegroup title="Files" name="FILES" group="Files" descriptor="File"}
		{insertable name="file" assign="file" title="File" type="file" required=true browseable=1}{/insertable}
		{insertable name="title" assign="title" title="Title" type="text"}{/insertable}
		{insertable name="image" assign="image" title="Image" type="file" accept="image/*" browseable=1}{/insertable}
		{insertable name="info" assign="info" title="Description" type="textarea"}{/insertable}
    {/insertablegroup}

    {foreach $FILES as $file}
        {assign var='object' value=\Core\Filestore\Factory::File($file['file'])}
        {assign var="ext" value="`$object->getExtension()`"}
        {if $ext === 'pdf' || $ext === 'jpg' || $ext === 'jpeg' || $ext === 'png' || $ext === 'gif'}
            {assign var="action" value="View"}
        {else}
            {assign var="action" value="Download"}
        {/if}

		<li class="collection-item file">
			<div class="collection-item-image">
                {if $file.image}
                    {img src="`$file.image`" dimensions="75x75"}
                {else}
                    {img src="`$file.file`" dimensions="75x75"}
                {/if}
			</div>

			<div class="collection-item-title">
				<a href="{link $file.file}" title="{$action} {$file.file|basename}">
	                {if $file.title}
	                    {$file.title}
	                {else}
	                    {$file.file|basename}
	                {/if}
				</a>
			</div>

            {if $file.info}
				<div class="collection-item-description">
                    {$file.info}
				</div>
            {/if}

			<div class="collection-item-controls">
				<a class="button" href="{link $file.file}" title="{$action} {$file.file|basename}">
					<i class="icon icon-download"></i>
					<span>{$action} {$file.file|basename}</span>
				</a>
			</div>

			<div class="collection-item-footnote">
				Filesize: {$object->getFilesize(true)}<br/>
				Modified: {date $object->getMTime() format='SD'}<br/>
				MD5 Hash: {$object->getHash()}
			</div>

		</li>
    {/foreach}
</ul>