{css src="css/navigation.css"}{/css}

{assign var='mobile_menu_render' value=true}
{assign var='mobile_menu_title' value='Navigation'}
{assign var='mobile_menu_icon' value='angle-down'}
{assign var='mobile_menu_breakpoint' value=700}


{if $mobile_menu_render}
	<div class="navigation-menu-mobile-handler" title="Toggle Menu" data-target="navigation-menu-{$model.id}" data-breakpoint="{$mobile_menu_breakpoint}">
		<span>{$mobile_menu_title}</span>
		<i class="icon icon-{$mobile_menu_icon}"></i>
	</div>
{/if}


<ul class="navigation-menu horizontal-layout track-click" data-track-category="{$model.name|str_to_id}" id="navigation-menu-{$model.id}">
	{foreach from=$entries item='e'}
		{assign var='element' value=$e.obj}
		{assign var='children' value=$e.children}
		{assign var='class' value=$e.class}
		{include file="widgets/navigation/_menu.inc.tpl"}
	{/foreach}
</ul>



	
{script library="jquery.hoverintent"}{/script}
{script location="foot"}
	<script>
	// A little script to ensure the nav responds to hover states
	$(function(){
		var $mobileHandlers = $('.navigation-menu-mobile-handler'),
			$menus = $('ul.navigation-menu');

		$menus
			.find('li')
			.mouseover(function(){
				$(this).addClass('navigation-menu-over');
				return true;
			})
			.mouseout(function(){ 
				$(this).removeClass('navigation-menu-over');
				return true;
			});
		
		if ( $.fn.hoverIntent) {
			$('.horizontal-layout li').hoverIntent({
				over: function(){
					$(this).addClass('navigation-menu-over');
					//$(this).find('ul').first().slideDown(250);
				},
				out: function(){
					$(this).removeClass('navigation-menu-over');
					//$(this).find('ul').first().slideUp(250);
				},
				timeout: 120
			});
		}

		$mobileHandlers.click(function() {
			var $this = $(this),
				$target = $('#' + $this.data('target'));

			if($target.hasClass('expanded')) {
				$this.removeClass('active');
				$target.removeClass('expanded');
			}
			else {
				$this.addClass('active');
				$target.addClass('expanded');
			}

			return false;
		});

		// On load, set the initial width
		$mobileHandlers.each(function() {
			var $this = $(this),
				breakpoint = $this.data('breakpoint');

			if(window.outerWidth < breakpoint) {
				$this.addClass('enabled');
				$('#' + $this.data('target')).addClass('mobile');
			}
		});


		$(window).resize(() => {
			$mobileHandlers.each(function() {
				var $this = $(this),
					breakpoint = $this.data('breakpoint'),
					$target = $('#' + $this.data('target'));

				if(window.outerWidth < breakpoint) {
					$this.addClass('enabled');
					$target.addClass('mobile');
				}
				else {
					$this.removeClass('enabled');
					$target.removeClass('mobile');
				}
			});
		});
	});
	</script>
{/script}
