<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

use Core\ConfigHandler;
use Core\Controller;
use Core\Forms\Form;
use Core\View;


/**
 * Description of PHPMailerController
 *
 * @author charlie
 */
class PHPMailerController extends Controller {
	public function config(){
		if(!\Core\user()->checkAccess('g:admin')){
			return View::STATUS_ACCESSDENIED;
		}
		
		$view = $this->getView();
		$request = $this->getRequest();
		
		$keys = [
			'/core/email/mailer',
			'/core/email/from',
			'/core/email/from_name',
			'/core/email/dynamic_sender',
			'/core/email/sandbox_to',
			'/phpmailer/sendmail/path',
			'/phpmailer/smtp/host',
			'/phpmailer/smtp/security',
			'/phpmailer/smtp/auth',
			'/phpmailer/smtp/domain',
			'/phpmailer/smtp/user',
			'/phpmailer/smtp/password',
			'/phpmailer/smtp/port',
		];

		$form = new Form();
		$form->set('callsmethod', 'AdminController::_ConfigSubmit');

		foreach($keys as $k){
			$c = ConfigHandler::GetConfig($k);
			$f = $c->asFormElement();
			// Don't need them grouped
			$f->set('group', '');
			$form->addElement($f);
		}
		$form->addElement('submit', ['value' => t('STRING_SAVE')]);

		$view->title = 't:STRING_PHPMAILER_CONFIG';
		$view->assign('form', $form);
	}
}
