<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Core;

/**
 * Description of Option
 *
 * @author charlie
 */
class DictItem {
	/**
	 * @var int|string Key of this Item
	 */
	public $key;
	
	/**
	 * @var mixed Value of this Item
	 */
	public $value;
	
	private $_translated = null;
	
	public function __construct($key, $value){
		$this->key   = $key;
		$this->value = $value;
	}
	
	/**
	 * Get the value of this key, while supporting i18n translations
	 * 
	 * @return mixed
	 */
	public function getTranslated(){
		if($this->_translated === null){
			// Value has NOT been translated yet, try to translate it!
			if(is_string($this->value) && strpos($this->value, 't:') === 0){
				// Value can be translated, so translate it!
				$this->_translated = \t(substr($this->value, 2));
			}
			else{
				// Value cannot be translated, simply set it to false so it doesn't check again.
				$this->_translated = false;
			}
		}
		
		return $this->_translated === false ? $this->value : $this->_translated;
	}
	
	public function setValue($value){
		$this->value = $value;
		$this->_translated = null;
	}
}
