<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Core\Formatter;

use Core\I18N\I18NLoader;
use Core\View;

/**
 * Description of GeoDistanceFormatter
 *
 * @author charlie
 */
class GeoDistanceFormatter {
	public static function Metric($value, $format = View::CTYPE_HTML){
		
		if($format === View::CTYPE_HTML) {
			$lang = I18NLoader::GetUsersLanguage();
			$imperial = strpos($lang, '_US') || strpos($lang, '_LI') || strpos($lang, '_BM');
			$prefix = $value < 0 ? '-' : '';
			$value = abs($value);
			
			if($imperial){
				$value *= 3.28084;
				
				if($value > 5280){
					$value = round($value / 5280);
					$suffix = 'mi';
				}
				elseif($value > 3){
					$value = round($value);
					$suffix = 'ft';
				}
				else{
					$value = round($value * 12);
					$suffix = 'in';
				}
			}
			else{
				if($value > 1000000){
					$value = round($value / 1000000, 2);
					$suffix = 'Mm';
				}
				elseif($value > 1000){
					$value = round($value / 1000, 2);
					$suffix = 'km';
				}
				elseif($value > 1){
					$suffix = 'm';
				}
				elseif($value > 0.01){
					$value = round($value * 100, 2);
					$suffix = 'cm';
				}
				elseif($value > 0.001){
					$value = round($value * 1000, 2);
					$suffix = 'mm';
				}
				else{
					$value = round($value * 1000000, 2);
					$suffix = 'nm';
				}
			}
			
			return $prefix . $value . ' ' . $suffix;
		}
		else{
			return $value;
		}
	}
}
