<?php
/**
 * Class file for FormCheckboxesInput
 *
 * @package Core\Forms
 * @author Charlie Powell <charlie@evalagency.com>
 * @copyright Copyright (C) 2009-2017  Charlie Powell
 * @license GNU Affero General Public License v3 <http://www.gnu.org/licenses/agpl-3.0.txt>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/agpl-3.0.txt.
 */

namespace Core\Forms;

/**
 * Class FormCheckboxesInput provides multiple checkboxes in one form element.
 *
 * @package Core\Forms
 */
class CheckboxesInput extends FormElement {
	public function  __construct($atts = null) {

		$this->_attributes['label-html'] = false;

		parent::__construct($atts);

		// Some defaults
		$this->_attributes['class'] = 'formelement formcheckboxesinput';
		$this->_attributes['multiple'] = true;
		$this->_validattributes     = array('accesskey', 'dir', 'disabled', 'lang', 'name', 'required', 'tabindex', 'style');
	}

	public function get($key) {
		if ($key === 'value' && isset($this->_attributes['options']) && sizeof($this->_attributes['options']) > 1) {
			// This should return an array if there are more than 1 option.
			if(!isset($this->_attributes['value'])) return array();
			elseif (!$this->_attributes['value']) return array();
			else return $this->_attributes['value'];
		}
		else {
			return parent::get($key);
		}
	}
}