<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Core\Parser\JPEGExif\Tags;

use Core\Date\DateTime;

/**
 * Description of DateTimeField
 *
 * @author charlie
 */
class DateTimeFieldTag extends ExifFieldTag {
	protected function _parse(array &$exif) {
		
		if(isset($exif['Geo'])){
			// Use the geolocated timezone to resolve this datetime!
			// This is because cameras record their local time when taking pictures. :/
			$tz = $exif['Geo']->timezone;
		}
		else{
			$tz = null;
		}
		
		$dt = new DateTime($this->raw, $tz);
		
		$this->value = $dt;
		$this->formatted = $dt->format('SDT');
	}
}
