<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Core\Parser\JPEGExif\Tags;

/**
 * Description of ExposureTime
 *
 * @author charlie
 */
class ExposureTimeTag extends ExifFieldTag {
	protected function _parse(array &$exif) {
		
		// These fields usually are listed as a fraction, or rational number.
		// Exposure is different because it SHOULD be listed in this format.
		
		if(preg_match('#/1$#', $this->raw)) {
			// This is a whole number.... simple enough!
			$this->value = substr($this->raw, 0, strpos($this->raw, '/'));
		}
		elseif(strpos($this->raw, '1/') === false) {
			// Well, it should have damnit!  It's in a weird format like 833/10000 or 3/25....
			list($num, $den) = explode('/', $this->raw);
			$this->value = '1/' . round($num / $den);
		}
		
		$this->formatted = $this->value . ' s';
	}
}
