<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Core\Parser\JPEGExif\Tags;

use Core\Formatter\GeoDistanceFormatter;

/**
 * Description of GPSAltitude
 *
 * @author charlie
 */
class GPSAltitudeTag extends RationalFieldTag {
	protected function _parse(array &$exif) {
		
		parent::_parse($exif);
		
		if($this->value == 0){
			$this->formatted = '';
			return;
		}
		
		if(strpos($exif['GPSAltitudeRef'], '1') !== false){
			// 1 indicates below sea level
			$this->value = (0 - $this->value);
		}

		$this->formatted = GeoDistanceFormatter::Metric($this->value, 'text/html');
	}
}
