<?php
/**
 * Created by IntelliJ IDEA.
 * User: charlie
 * Date: 3/22/19
 * Time: 12:33 AM
 */

namespace Core\Parser\SVGMeta;

use Core\Filestore\File;
use Core\Parser\ImageParser;
use Core\XMLLoader;
use Core\Parser\ImageMetaTag;

/**
 * Class SVGMetaParser
 *
 * Common strings:
 *
 * t:STRING_CORE_PARSER_IMAGEMETA_TITLE
 * t:STRING_CORE_PARSER_IMAGEMETA_DATE
 * t:STRING_CORE_PARSER_IMAGEMETA_CREATOR
 * t:STRING_CORE_PARSER_IMAGEMETA_RIGHTS
 * t:STRING_CORE_PARSER_IMAGEMETA_PUBLISHER
 * t:STRING_CORE_PARSER_IMAGEMETA_LANGUAGE
 *
 * @package Core\Parser\SVGMeta
 */
class SVGMetaParser extends ImageParser {
	/**
	 * @var ImageMetaTag[] Array of tags from this meta data
	 */
	public $fields = [];

	public function parseFile(File $file) {

		$this->fields = [];


		$loader = new XMLLoader();
		$loader->setRootName('svg');
		$loader->loadFromFile($file);

		// XPath isn't working here for some reason, do it the hard way.
		$root = $loader->getRootDOM();
		foreach($root->childNodes as $c1) {
			if($c1->nodeName == 'metadata') {
				foreach($c1->childNodes as $c2) {
					if($c2->nodeName == 'rdf:RDF') {
						foreach($c2->childNodes as $c3) {
							if($c3->nodeName == 'cc:Work') {
								foreach($c3->childNodes as $c4) {
									switch($c4->nodeName) {
										case 'dc:format':
										case 'dc:type':
										case '#text':
											// skip
											continue;
										default:
											$tag = new ImageMetaTag();
											$tag->formatted = $tag->raw = $tag->value = trim($c4->nodeValue);
											$tag->title = 'STRING_CORE_PARSER_IMAGEMETA_' .
												strtoupper(
													substr(
														$c4->nodeName,
														strpos($c4->nodeName, ':')+1
													)
												);
											$this->fields[] = $tag;
									}
								}
							}
						}
					}
				}
			}
		}
	}
}