<?php

namespace Core\User;

use Core\ListingTable\Table;
use Core\FilterForm;
use Core\Date\DateTime;
use Core\Core;
use UserModel;

class UserGroupTable extends Table {
	private $_accessPermissions;
	private $_multisite;

	public function __construct() {
		$this->setModelName('UserGroupModel');
		$this->addClassname('listing-table-usergroups');

		$this->_accessPermissions = \Core\user()->checkAccess('p:/user/permissions/manage');
		$this->_multisite = (Core::IsComponentAvailable('multisite') && MultiSiteHelper::IsEnabled());

		parent::__construct();

		$this->setDefaultViewMode('collection');
	}

	protected function _setupColumns() {

		if($this->_multisite) {
			$this->addColumn('site');
		}
		$this->addColumn('name');
		$this->addColumn('description');
		if($this->_accessPermissions) {
			$this->addColumn('permissions')->disableSortable();
		}
	}

}