<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Core\ViewMeta;

use Core\Core;
use UserModel;

/**
 * Defines the name of the document's author.
 *
 * @author charlie
 */
class Author extends Base {
	
	public function fetch() : array {
		$html = [];
		
		if($this->_content instanceof UserModel){
			$user   = $this->_content;
			$author = $this->_content->getDisplayName();
		}
		elseif($this->_contentKey){
			// The key is the ID of the user, set from the user autocomplete form element usually.
			$user = UserModel::Construct($this->_contentKey);
			$author = $user->getDisplayName();
		}
		else{
			$user   = null;
			$author = $this->_content;
		}
		
		
		if($author){
			$html[] = '<meta name="author" content="' . htmlentities($author) . '"/>';
		}
		
		
		// "Socially enabled" sites also get the link attribute!
		if($user && Core::IsComponentAvailable('user-social')){
			$html[] = '<link rel="author" href="' . UserSocialHelper::ResolveProfileLink($user) . '"/>';
		}

		return $html;
	}
}