<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Core\ViewMeta;

/**
 * Contains a short and accurate summary of the content of the page. 
 * 
 * Several browsers, like Firefox and Opera, 
 * use this as the default description of bookmarked pages.
 *
 * @author charlie
 */
class Description extends Base {
	
	public function __toString() : string {
		// The description should be limited to 300 characters.
		
		$content = (strlen($this->_content) > 300) ?
			substr($this->_content, 0, 297) . '...' :
			$this->_content;
		
		return htmlentities($content);
	}
	
	public function fetch() : array {
		$html = [];
		
		if(!$this->_content){
			return $html;
		}
		
		$content = $this->__toString();
		
		$html[] = '<meta name="description" content="' . $content . '"/>';
		
		return $html;
	}
}
