<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Core\ViewMeta;

/**
 * Gives hints about the size of the initial size of the viewport. Used by mobile devices only.
 *
 * @author charlie
 */
class Viewport extends GenericMeta {
	/**
	 * @var int Pixel width of the viewport, or NULL to allow the viewport to adapt to the device width
	 */
	public $width;
	
	/**
	 * @var float Ratio between the device width and the viewport size
	 */
	public $scale = 1.0;
	
	protected $_name = 'viewport';
	
	public function __toString() : string {
		$parts = [];
		
		$parts[] = 'width=' . ($this->width ? $this->width : 'device-width');
		$parts[] = 'initial-scale=' . $this->scale;
		
		return implode(', ', $parts);
	}
}
