
<div class="{$element->getClass()} {$element->get('id')}">

	<div class="form-element-label">
		{$element->get('title')|escape}
		{if $element->get('required')}<span class="form-element-required-mark" title="Required Field"> *</span>{/if}
	</div>

	{if $element->get('description')}
		<p class="form-element-description">{$element->get('description')}</p>
	{/if}

	<div class="form-element-value" id="{$element->get('id')}">
		{assign var=buttonvalue value=$element->getValue()}
		<label class="button-creator-text" title="Button Text">
			<i class="icon icon-font"></i>
			<input type="text" name="{$element->get('name')}[text]" placeholder="Button Text" value="{$buttonvalue.text|escape}"/>
		</label>

		<label class="button-creator-link" title="Link Target">
			<i class="icon icon-link"></i>
			<input type="url" name="{$element->get('name')}[href]" placeholder="https://" value="{$buttonvalue.href}"/>
		</label>

		<label class="button-creator-title" title="Button Title Text">
			<i class="icon icon-lightbulb"></i>
			<input type="text" name="{$element->get('name')}[title]" placeholder="Hover Title Text" value="{$buttonvalue.title|escape}"/>
		</label>

		<label class="button-creator-size" title="Button Size">
			<i class="icon icon-text-height"></i>
			<select name="{$element->get('name')}[size]">
				<option value="" {if $buttonvalue.size === ''}selected="selected"{/if}>Default Size</option>
				<option value="small" {if $buttonvalue.size === 'small'}selected="selected"{/if}>Small</option>
				<option value="large" {if $buttonvalue.size === 'large'}selected="selected"{/if}>Large</option>
				<option value="xlarge" {if $buttonvalue.size === 'xlarge'}selected="selected"{/if}>Extra Large</option>
			</select>
		</label>

		<div class="button-creator-color">
			<div class="group-label">
				Default Color
			</div>

			<label class="foreground-color-swatch" >
				<i class="icon icon-font"></i>
				<input type="color" name="{$element->get('name')}[color]" title="Text Color" value="{$buttonvalue.color}"/>
			</label>
			<label class="background-color-swatch">
				<i class="icon icon-tint"></i>
				<input type="color" name="{$element->get('name')}[background_color]" title="Background Color" value="{$buttonvalue.background_color}"/>
			</label>
			<label class="border-color-swatch">
				<i class="icon icon-border-style"></i>
				<input type="color" name="{$element->get('name')}[border_color]" title="Border Color" value="{$buttonvalue.border_color}"/>
			</label>
		</div>

		<div class="button-creator-color-hover">
			<div class="group-label">
				Hover Color
			</div>

			<label class="foreground-color-swatch" >
				<i class="icon icon-font"></i>
				<input type="color" name="{$element->get('name')}[color_hover]" title="Text Color" value="{$buttonvalue.color_hover}"/>
			</label>
			<label class="background-color-swatch">
				<i class="icon icon-tint"></i>
				<input type="color" name="{$element->get('name')}[background_color_hover]" title="Background Color" value="{$buttonvalue.background_color_hover}"/>
			</label>
			<label class="border-color-swatch">
				<i class="icon icon-border-style"></i>
				<input type="color" name="{$element->get('name')}[border_color_hover]" title="Border Color" value="{$buttonvalue.border_color_hover}"/>
			</label>
		</div>
	</div>
</div>

<script>
	(() => {
		document.addEventListener('loaded', evt => {
			let match = evt.target.closest('.button-creator-link');
			if(match) {
				let input = match.querySelector('input');
				if(input.value.indexOf('/') === 0) {
					Core.Ajax(
						Core.ROOT_URL + 'page/url',
						{
							method: 'GET',
							parameters: {
								q: input.value
							},
							callback: (data, type) => {
								if(data.url) {
									input.value = data.url;
								}
							}
						}
					)
				}
			}
		});
	})();
</script>
