{assign var='type' value='color'}

<div class="{$class} {$id}">

	<label for="{$name}" class="form-element-label">
        {$title|escape}
        {if $required}<span class="form-element-required-mark" title="Required Field"> *</span>{/if}
	</label>

    {if $error}
		<span class="form-element-error">{$error}</span>
    {/if}

    {if $description}
        {if $error || strpos($description, "\n") || strpos($description, "<br/>") || strpos($description, "<br>")}
			<p class="form-element-description">{$description}</p>
        {else}
			<span class="form-element-description">{$description}</span>
        {/if}
    {/if}

	<div class="form-element-value">
		{if !$required}
			<a href="#" class="button formcolorinput-value-select">
				<i class="icon icon-eye-dropper"></i>
				<span>Set Color</span>
			</a>
        {/if}
		<span class="formcolorinput-value-text">{$value}</span>
		<input type="text" {$input_arguments}/>
		{if !$required}
			<span class="formcolorinput-value-reset">
				<i class="icon icon-times"></i>
				<span>Remove Color</span>
			</span>
        {/if}
	</div>
</div>

{script location="foot"}<script>
	(function() {
		document.addEventListener('click', evt => {
			let match;

			if(evt.target.closest('.formcolorinput .formcolorinput-value-select')) {
				let wrapper = evt.target.closest('.form-element-value'),
					input = wrapper.querySelector('input'),
					valueLabel = wrapper.querySelector('.formcolorinput-value-text');

				input.type = 'color';
				valueLabel.innerHTML = input.value;
				wrapper.classList.add('has-value');
				wrapper.classList.remove('no-value');

				input.dispatchEvent(new MouseEvent('click'));

				evt.preventDefault();
			}

			if(evt.target.closest('.formcolorinput .formcolorinput-value-reset')) {
				let wrapper = evt.target.closest('.form-element-value'),
					input = wrapper.querySelector('input');

				input.type = 'text';
				input.value = '';
				wrapper.classList.remove('has-value');
				wrapper.classList.add('no-value');

				// in case the underlying element has something watching it.
				input.dispatchEvent(new Event('change'));

				evt.preventDefault();
			}
		});

		document.addEventListener('change', evt => {
			if(evt.target.closest('.formcolorinput input')) {
				let wrapper = evt.target.closest('.form-element-value');

				// Set the wrapper text
				wrapper.querySelector('.formcolorinput-value-text').innerHTML = evt.target.value;

				// Ensure the structure matches what we're expecting, just in case this value was changed via javascript.
				if(evt.target.value) {
					wrapper.classList.add('has-value');
					wrapper.classList.remove('no-value');
					evt.target.type = 'color';
				}
				else {
					wrapper.classList.remove('has-value');
					wrapper.classList.add('no-value');
					evt.target.type = 'text';
				}
			}
		});


		document.querySelectorAll('.formcolorinput input').forEach(el => {
			let wrapper = el.closest('.form-element-value');

			if(el.value) {
				// Value is set, ensure it's a color input and set the label.
				el.type = 'color';
				el.closest('.form-element-value').querySelector('.formcolorinput-value-text').innerHTML = el.value;
				wrapper.classList.add('has-value');
				wrapper.classList.remove('no-value');
			}
			else {
				wrapper.classList.add('no-value');
			}
		});
	})();
</script>{/script}