{css}<style>
	.icons-list {
		display: flex;
		flex-wrap: wrap;
		list-style: none;
    }
	.icons-list li {
		flex: 1 16em;
		margin: 0.25em;
    }
    .icons-list i {
		font-size: 2em;
    }
	.icons-list span {
		opacity: 0.8;
    }
</style>{/css}

<main class="width-wrapper">
	<h1>Test General UI/UX (H1 tag)</h1>

	<p class="message-tutorial">
		Here you can preview how various common elements of your site look.
	</p>

	<form action="" method="GET">
		<select name="skin">
			<option value="">-- Select Skin to Preview--</option>
			{foreach $skins as $s}
				<option value="{$s->getPathFragment()}" {if $skin === $s->getPathFragment()}selected="selected"{/if}>{$s->getTitle()}</option>
			{/foreach}
		</select>

		<input type="submit" value="Set"/>
	</form>
	<hr/>

	<ul class="toc">


		<li>
			<a href="#tutorial-badges">Badges</a>
		</li>
		<li>
			<a href="#tutorial-buttons">Buttons</a>
			<ul>
				<li>
					<a href="#tutorial-buttons-basic">Basic Buttons</a>
				</li>
				<li>
					<a href="#tutorial-buttons-icons">Icon Buttons</a>
				</li>
				<li>
					<a href="#tutorial-buttons-grouped">Grouped Buttons</a>
				</li>
				<li>
					<a href="#tutorial-buttons-tiled">Tiled Buttons</a>
				</li>
				<li>
					<a href="#tutorial-buttons-states">Button States</a>
				</li>
				<li>
					<a href="#tutorial-buttons-icon-action-button">Icon Action Buttons</a>
				</li>
			</ul>
		</li>
		<li>
			<a href="#tutorial-controls">Controls</a>
		</li>
		<li>
			<a href="#tutorial-collections">Collections</a>
		</li>
		<li>
			<a href="#tutorial-headers">Headers</a>
		</li>
		<li>
			<a href="#tutorial-icons">Icons</a>
		</li>
		<li>
			<a href="#tutorial-links">Links</a>
			<ul>
				<li>
					<a href="#tutorial-links-basic">Basic Links</a>
				</li>
				<li>
					<a href="#tutorial-links-tiled">Tiled Links</a>
				</li>
			</ul>
		</li>
		<li>
			<a href="#tutorial-lists">Lists</a>
		</li>
		<li>
			<a href="#tutorial-messages">Messages</a>
		</li>
		<li>
			<a href="#tutorial-paragraphs">Paragraphs</a>
		</li>
		<li>
			<a href="#tutorial-tiles">Tiles</a>
		</li>
	</ul>


	<section class="example">
		<h2 id="tutorial-messages">Block-level Messages</h2>

		<p class="message-tutorial">
			Messages are the default reporting/output system in Core, they can be rendered manually or with the built-in messaging system.
		</p>

		{foreach ['note', 'info', 'success', 'deprecated', 'warning', 'error', 'tutorial'] as $class}
			<p class="message-{$class}">This is a "message-{$class}" type message box with <a href="#">a link somewhere</a>!</p>
		{/foreach}
	</section>


	<section class="example">
		<h2>Long-Polling Inline Actions</h2>

		<p class="message-tutorial">
			These are rare, but used in the admin reinstallation page.
		</p>

		<form id="progress-log-form" name="progress-log-form" target="progress-log" method="POST" action="">
			<input type="submit" value="Perform Long Progress Test"/>
		</form>

		{progress_log_iframe}
	</section>


	<section class="example">
		<h2 id="tutorial-links">Links</h2>

		<h3 id="tutorial-links-basic">Basic link</h3>
		{foreach $buttons as $button}
			<a href="#">
				{$button.text}
			</a>
		{/foreach}

		<h3 id="tutorial-links-tiled">Tiled link</h3>
		{foreach $buttons as $button}
			<a href="#" class="tile-link">
				<i class="icon icon-{$button.icon}"></i>
				<span>{$button.text}</span>
			</a>
		{/foreach}
	</section>

	<section class="example">
		<h2 id="tutorial-buttons">Buttons</h2>

		<h3 id="tutorial-buttons-basic">Basic buttons with no icon</h3>
		{foreach $buttons as $button}
			<a href="#" class="button">
				{$button.text}
			</a>
		{/foreach}

		<h3 id="tutorial-buttons-icons">Buttons with icons</h3>
		{foreach $buttons as $button}
			<a href="#" class="button">
				<i class="icon icon-{$button.icon}"></i>
				<span>{$button.text}</span>
			</a>
		{/foreach}

		<h3 id="tutorial-buttons-grouped">Grouped Buttons</h3>
		<div class="button-group">
			{foreach $buttons as $button}
				<a href="#" class="button">
					<i class="icon icon-{$button.icon}"></i>
					<span>{$button.text}</span>
				</a>
			{/foreach}
		</div>

		<h3 id="tutorial-buttons-tiled">Tiled Buttons</h3>
		{foreach $buttons as $button}
			<a href="#" class="tile-button">
				<i class="icon icon-{$button.icon}"></i>
				<span>{$button.text}</span>
			</a>
		{/foreach}

		<h3 id="tutorial-buttons-states">Button States</h3>
		<a href="#" class="button disabled">
			<i class="icon icon-times"></i>
			<span>Disabled "&lt;a&gt;" Button</span>
		</a>

		<a href="#" class="button active">
			<i class="icon icon-check"></i>
			<span>Active "&lt;a&gt;" Button</span>
		</a>

		<a href="#" class="button button-primary">
			<i class="icon icon-check"></i>
			<span>Primary "&lt;a&gt;" Button</span>
		</a>

		<input type="button" disabled="disabled" value="Input Button (Disabled)"/>

		<input type="button" class="active" value="Input Button (Active)"/>

		<input type="submit" value="Submit Button"/>


		<h3 id="tutorial-buttons-sizes">Button Sizes</h3>

		<a href="#" class="button button-size-small">
			<i class="icon icon-angle-down"></i>
			<span>Small Button</span>
		</a>

		<a href="#" class="button">
			<span>Default Button</span>
		</a>

		<a href="#" class="button button-size-large">
			<i class="icon icon-angle-up"></i>
			<span>Large Button</span>
		</a>

		<a href="#" class="button button-size-xlarge">
			<i class="icon icon-angle-double-up"></i>
			<span>XLarge Button</span>
		</a>


		<h3 id="tutorial-buttons-icon-action-button">Icon Action Buttons</h3>
		<a href="#" class="button button-icon-action">
			<i class="icon icon-add"></i>
		</a>

		<a href="#" class="button button-icon-action">
			<i class="icon icon-times"></i>
		</a>

		<a href="#" class="button button-icon-action">
			<i class="icon icon-trash"></i>
		</a>

		<a href="#" class="button button-icon-action">
			<i class="icon icon-edit"></i>
		</a>

		<a href="#" class="button button-icon-action">
			<i class="icon icon-eye"></i>
		</a>

		<a href="#" class="button button-icon-action active">
			<i class="icon icon-eye"></i>
		</a>

		<a href="#" class="button button-icon-action button-primary">
			<i class="icon icon-eye"></i>
		</a>

		<a href="#" class="button button-icon-action button-size-small">
			<i class="icon icon-angle-down"></i>
		</a>

		<a href="#" class="button button-icon-action button-size-large">
			<i class="icon icon-angle-up"></i>
		</a>



		<h3 id="tutorial-buttons-toggle">Toggle Buttons</h3>

		Buttons support being rendered as toggles, for example something disabled
		<a href="#" class="button button-toggle" title="Inactive button toggle">
			<span>Inactive Button</span>
		</a>

		and something enabled
		<a href="#" class="button button-toggle active" title="Active button toggle">
			<span>Active Button</span>
		</a>

	</section>


	<section class="example">
		<h2 id="tutorial-controls">Controls</h2>

		<p class="message-tutorial">
			Controls provide inline actions for everything in Core and are used exensively.
		</p>

		<h3>Default Fetch</h3>
		{$controls->fetch()}

		<h3>Fetch as Sub Menu <code>(fetch('subtrays'))</code></h3>
		{$controls->fetch('subtrays')}

		<h3>Fetch as Icon Buttons <code>(fetch('buttons', ['only-icons']))</code></h3>
		{$controls->fetch('buttons', ['only-icons'])}

		<h3>Fetch as Buttons w/o Icons <code>(fetch('buttons', ['no-icons']))</code></h3>
		{$controls->fetch('buttons', ['no-icons'])}

		<h3>Manual / Basic Control</h3>
		<div class="controls" role="menu">
			<a href="#" role="menuitem">
				<i class="icon icon-check"></i>
				<span>Thing</span>
			</a>
			<a href="#" role="menuitem">
				<i class="icon icon-eye"></i>
				<span>Another Item</span>
			</a>
		</div>

	</section>


	<section class="example">
		<fieldset class="collapsible collapsed">
			<legend>Collapsed Fieldset w/legend (click me!)</legend>
			<div>
				Content!
			</div>
		</fieldset>

		<fieldset class="collapsible collapsed">
			<div class="fieldset-title">
				Collapsed Fieldset w/.fieldset-title (click me!)
				<i class="icon icon-chevron-down expandable-hint"></i>
				<i class="icon icon-chevron-up collapsible-hint"></i>
			</div>
			<div>
				Content!
			</div>
		</fieldset>
	</section>

	<section class="example">
		<h2 id="tutorial-collections">Collections</h2>

		<h3>UL/LI Collection Items</h3>

		<ul class="listing-collection">
			<li class="collection-item">
				<div class="collection-item-image">
					{img placeholder="person" dimensions="50x50"}
				</div>

				<div class="collection-item-title">
					User 1
				</div>

				<div class="collection-item-description">
					Some content about this user
				</div>

				<div class="collection-item-controls">
					<a class="button" href="#">Action</a>
				</div>

				<div class="collection-item-footnote">
					Some footnote about this item
				</div>
			</li>

			<li class="collection-item">
				<div class="collection-item-image">
					{img placeholder="person" dimensions="50x50"}
				</div>

				<div class="collection-item-title">
					User 2
				</div>

				<div class="collection-item-description">
					Some content about this user
				</div>

				<div class="collection-item-controls">
					<a class="button" href="#">Action</a>
				</div>

				<div class="collection-item-footnote">
					Some footnote about this item
				</div>
			</li>
		</ul>


		<h3>UL/LI Collection Items With Sidenote</h3>

		<ul class="listing-collection">
			<li class="collection-item">
				<div class="collection-item-image">
					{img placeholder="person" dimensions="50x50"}
				</div>

				<div class="collection-item-title">
					User 1
				</div>

				<div class="collection-item-description">
					Some content about this user
				</div>

				<div class="collection-item-sidenote">
					This is a side note about this item
				</div>

				<div class="collection-item-footnote">
					Some footnote about this item
				</div>
			</li>

			<li class="collection-item">
				<div class="collection-item-image">
					{img placeholder="person" dimensions="50x50"}
				</div>

				<div class="collection-item-title">
					User 2
				</div>

				<div class="collection-item-description">
					Some content about this user
				</div>

				<div class="collection-item-sidenote">
					This is a side note about this item
				</div>

				<div class="collection-item-footnote">
					Some footnote about this item
				</div>
			</li>
		</ul>


		<h3>UL/LI Collection Items With Header Content</h3>

		<ul class="listing-collection">
			<li class="collection-item">
				<div class="collection-item-image">
					{img placeholder="person" dimensions="100x100"}
				</div>

				<div class="collection-item-header">
					<span class="collection-item-title">User 1</span>
					<ol>
						<li>Attribute 1</li>
						<li>Attribute 2</li>
					</ol>
				</div>
			</li>

			<li class="collection-item">
				<div class="collection-item-image">
					{img placeholder="person" dimensions="100x100"}
				</div>

				<div class="collection-item-header">
					<span class="collection-item-title">User 2</span>
					<ol>
						<li>Attribute 1</li>
						<li>Attribute 2</li>
					</ol>
				</div>
			</li>
		</ul>
	</section>


	<section class="example">
		<h2 id="tutorial-tiles">Tiles</h2>

		<ul class="tile-container">
			<li class="tile">
				<div class="tile-image">
					{img placeholder="person" dimensions="100x100"}
				</div>

				<div class="tile-title">
					User 1
				</div>

				<div class="tile-description">
					Some content about this user
				</div>

				<div class="tile-controls">
					<a class="button" href="#">Action</a>
				</div>

				<div class="tile-footnote">
					Some footnote about this item
				</div>
			</li>

			<li class="tile">
				<div class="tile-image">
					{img placeholder="person" dimensions="100x100"}
				</div>

				<div class="tile-title">
					User 2
				</div>

				<div class="tile-description">
					Some content about this user
				</div>

				<div class="tile-controls">
					<a class="button" href="#">Action</a>
				</div>

				<div class="tile-footnote">
					Some footnote about this item
				</div>
			</li>
		</ul>

	</section>

	<section class="example">
		<h2 id="tutorial-badges">Badges</h2>
		<p>
			Badges can provide snippet of details embedded with other items.  By default they are not coloured, but can be
			styled with something similar to the following code in SCSS:
		</p>
		<pre class="scss">
.badge {
	&.my-item-key {
		background-color: var(--info-background-color-primary, #d9d9d9);
		color: var(--info-color-primary, #0e0e0e);
		border-color: var(--info-border-color-primary, #d9d9d9);
		i {
			color: var(--info-icon-color-primary, #0e0e0e);
		}
	}
}
		</pre>

		{foreach $buttons as $button}
			<span class="badge" title="{$button.text} Badge">
				<i class="icon icon-{$button.icon}"></i>
				<span>{$button.text}</span>
			</span>
		{/foreach}

		<hr/>
		<p>
			Additionally, Core provides some pre-defined badges for convenience.
		</p>

		<span class="badge">
			no class
		</span>

		<span class="badge note">
			.note
		</span>

		<span class="badge info">
			.info
		</span>

		<span class="badge success">
			.success
		</span>

		<span class="badge warning">
			.warning
		</span>

		<span class="badge error">
			.error
		</span>

		<hr/>
		<p>
			Core 7.2 Feature: Badges can have badge notifications
		</p>

		<span class="badge">
			no class
			<span class="badge-notification">{rand(1,9)}</span>
		</span>

		<span class="badge note">
			.note
			<span class="badge-notification">{rand(10,99)}</span>
		</span>

		<span class="badge info">
			.info
			<span class="badge-notification badge-notification-many">{rand(100,199)}</span>
		</span>

		<span class="badge success">
			.success
			<span class="badge-notification badge-notification-manymany">{rand(1000,9999)}</span>
		</span>

		<span class="badge warning">
			.warning
			<span class="badge-notification">{rand(1,9)}</span>
		</span>

		<span class="badge error">
			.error
			<span class="badge-notification">{rand(1,9)}</span>
		</span>

		<hr/>

		<p>
			Some badges can have dynamic background colors.
			These are useful to use with <code>\Core\color_brightness_level()</code> to detect the color brightness.
		</p>

		<pre class="php">
/**
 * Get the brightness value of a given color, between 0 - 255.
 *
 * 0 - 122 is dark
 * 123 - 255 is bright
 *
 * @param string $color
 *
 * @return int
 */
function color_brightness_level(string $color) : int;
		</pre>

		{assign var=steps value=['#ffffff', '#dddddd', '#bbbbbb', '#999999', '#777777', '#555555', '#333333']}
		{foreach $steps as $step}
			<span class="badge {if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}" style="background-color:{$step};">
				.{if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}
			</span>
		{/foreach}

		<br/>
		{assign var=steps value=['#ff0000', '#dd0000', '#bb0000', '#990000', '#770000', '#550000', '#330000']}
		{foreach $steps as $step}
			<span class="badge {if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}" style="background-color:{$step};">
				.{if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}
			</span>
		{/foreach}

		<br/>
		{assign var=steps value=['#00ff00', '#00dd00', '#00bb00', '#009900', '#007700', '#005500', '#003300']}
		{foreach $steps as $step}
			<span class="badge {if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}" style="background-color:{$step};">
				.{if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}
			</span>
		{/foreach}

		<br/>
		{assign var=steps value=['#0000ff', '#0000dd', '#0000bb', '#000099', '#000077', '#000055', '#000033']}
		{foreach $steps as $step}
			<span class="badge {if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}" style="background-color:{$step};">
				.{if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}
			</span>
		{/foreach}

		<br/>
		{assign var=steps value=['#ffff00', '#dddd00', '#bbbb00', '#999900', '#777700', '#555500', '#333300']}
		{foreach $steps as $step}
			<span class="badge {if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}" style="background-color:{$step};">
				.{if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}
			</span>
		{/foreach}

		<br/>
		{assign var=steps value=['#ff00ff', '#dd00dd', '#bb00bb', '#990099', '#770077', '#550055', '#330033']}
		{foreach $steps as $step}
			<span class="badge {if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}" style="background-color:{$step};">
				.{if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}
			</span>
		{/foreach}

		<br/>
		{assign var=steps value=['#00ffff', '#00dddd', '#00bbbb', '#009999', '#007777', '#005555', '#003333']}
		{foreach $steps as $step}
			<span class="badge {if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}" style="background-color:{$step};">
				.{if \Core\color_brightness_level($step) >= 123}light-background{else}dark-background{/if}
			</span>
		{/foreach}


	</section>


	<section class="example">
		<h2 id="tutorial-headers">Headers</h2>

		<h1>Header #1</h1>
		<h2>Header #2</h2>
		<h3>Header #3</h3>
		<h4>Header #4</h4>
	</section>


	<section class="example">
		<h2 id="tutorial-paragraphs">Paragraph</h2>

		{$lorem_p}
	</section>


	<section class="example">
		<h2 id="tutorial-lists">Lists</h2>
		<ul>
			{foreach $lis as $li}
				<li>{$li}</li>
			{/foreach}
		</ul>

		<ol>
			{foreach $lis as $li}
				<li>{$li}</li>
			{/foreach}
		</ol>
	</section>

	<section class="example">
		<h2 id="tutorial-icons">Icons</h2>
		<p class="message-tutorial">
			Core Plus ships with the community version of <a href="https://fontawesome.com/" target="_blank">Font Awesome</a>
			and thus its icons are available out-of-the-box.
			<br/><br/>
			Please note, the icon prefixes have been changed to be more generic, please use <code>icon-</code> instead of fa- as the prefix.
			<br/><br/>
			For example, <code>&lt;i class="icon icon-user"&gt;</code>
		</p>

		<ul class="icons-list">
            {foreach $icons as $icon}
				<li>
					<i class="icon icon-{$icon}"></i>
					<span>{$icon}</span>
				</li>
            {/foreach}
		</ul>


		<p class="message-tutorial">
			Brand icons are also available, though are shipped in a different font file as of the bundled version, so
			a different classname is required.
			<br/><br/>
			Usage: <code>&lt;i class="fab icon-facebook"&gt;</code>
		</p>

		<ul class="icons-list">
            {foreach $icon_brands as $icon}
				<li>
					<i class="fab icon-{$icon}"></i>
					<span>{$icon}</span>
				</li>
            {/foreach}
		</ul>
	</section>
</main>
