<ul class="installer-progress">
	<li class="complete">
		✓
		Requirement Checks
	</li>
	<li class="complete">
		✓
		Configuration
	</li>
	<li class="complete">
		✓
		Database
	</li>
	<li class="active">
		Deploy Configuration
	</li>
	<li>
		Complete
	</li>
</ul>

<h1>Save Configuration</h1>

{if !$passed}
	{if $is_cpanel}
		<p>
			Core Plus is not able to automatically create the configuration, so please follow these steps to do so manually.
		</p>
		<ol>
			<li>Browse to CPanel >> Files >> File Manager</li>
			<li>Browse to <strong><code>{$path|dirname}</code></strong></li>
			<li>Create a new file called <strong><code>{$path|basename}</code></strong></li>
			<li>Edit that file and paste the following contents into it</li>
		</ol>
	{else}
		<p>Create {$path} and paste the following configuration.</p>
	{/if}

	<a href="#" id="copy-config-contents-target">
		Copy Contents to Clipboard
	</a>
	
	<pre>
{$contents|escape}
	</pre>

	<textarea id="config-contents" style="display:none;">
{$contents|escape}
	</textarea>
	
	<form action="" method="POST">
		<input type="hidden" name="_retry" value="install"/>
		{if $first_try}
			<input type="submit" value="OK, Check My Work!"/>
		{else}
			<input type="submit" value="Recheck"/>
		{/if}
	</form>
{else}
	Framework ready to be installed!
	<form action="" method="POST">
		<input type="hidden" name="_submit" value="install"/>
		<input type="submit" value="Finish"/>
	</form>
{/if}

<script>
	$(function() {
		$('#copy-config-contents-target').click(function() {
			// copy-config-contents-target
			var $target = $('#config-contents');
			$target.show().select();
			if(document.execCommand("copy")) {
				alert('Copied contents to clipboard!  Go ahead and paste into configuration.xml!');
			}
			$('body').focus();
			$target.hide();

			return false;
		});
	});
</script>