<ul class="installer-progress">
	<li class="complete">
		✓
		Requirement Checks
	</li>
	<li class="active">
		Configuration
	</li>
	<li>
		Database
	</li>
	<li>
		Deploy Configuration
	</li>
	<li>
		Complete
	</li>
</ul>

<h1>Site Configuration</h1>

<form action="" method="POST">
	<input type="hidden" name="_submit" value="config"/>
	<input type="hidden" name="_config" value="1"/>
	
	<div class="formelement formcheckboxinput" style="float:right;">
		<label for="advanced-options">Toggle Advanced Options</label>
		<input type="checkbox" id="advanced-options"/>
	</div>
	<div class="clear"></div>
	<br/>
	
	{foreach $elements as $element}
		<div class="formelement formelement-{$element.type}-input {if $element.advanced}advanced{/if}">
			<div class="formelement-labelinputgroup">
				<label for="formelement-{$element.name}">{$element.title}</label>
				
				{if $element.type === 'select'}
					<select name="{$element.name}" id="formelement-{$element.name}">
						{foreach $element.options as $opt}
							<option value="{$opt}" {if $opt === $element.value}selected="selected"{/if}>{$opt}</option>
						{/foreach}
					</select>
				{elseif $element.type === 'checkbox'}
					<input type="checkbox" name="{$element.name}" id="formelement-{$element.name}" value="1" {if $element.value === 'true'}checked="checked"{/if}/>
				{else}
					<input type="{$element.type}" name="{$element.name}" id="formelement-{$element.name}" value="{$element.value|escape}"/>
				{/if}
			</div>

			<div class="clear"></div>

			{if $element.description}
				<div class="formdescription">{$element.description}</div>
			{/if}
		</div>
	{/foreach}
	<br/>
	
	<input type="submit" value="Next &raquo;"/>
</form>


<script>
	$(function(){
		var cdnopts = [
			{
				group: 'local',
				$wrapper: $('#formelement-CDN_LOCAL_ASSETDIR').closest('.formelement')
			},
			{
				group: 'local',
				$wrapper: $('#formelement-CDN_LOCAL_PUBLICDIR').closest('.formelement')
			},
			{
				group: 'local',
				$wrapper: $('#formelement-CDN_LOCAL_PRIVATEDIR').closest('.formelement')
			},
			{
				group: 'ftp',
				$wrapper: $('#formelement-CDN_FTP_USERNAME').closest('.formelement')
			},
			{
				group: 'ftp',
				$wrapper: $('#formelement-CDN_FTP_PASSWORD').closest('.formelement')
			},
			{
				group: 'ftp',
				$wrapper: $('#formelement-CDN_FTP_HOST').closest('.formelement')
			},
			{
				group: 'ftp',
				$wrapper: $('#formelement-CDN_FTP_PATH').closest('.formelement')
			},
			{
				group: 'ftp',
				$wrapper: $('#formelement-CDN_FTP_URL').closest('.formelement')
			},
			{
				group: 'ftp',
				$wrapper: $('#formelement-CDN_FTP_ASSETDIR').closest('.formelement')
			},
			{
				group: 'ftp',
				$wrapper: $('#formelement-CDN_FTP_PUBLICDIR').closest('.formelement')
			},
			{
				group: 'ftp',
				$wrapper: $('#formelement-CDN_FTP_PRIVATEDIR').closest('.formelement')
			}
		];
		$('#advanced-options').click(function(){
				if($(this).is(':checked')){
					$('.advanced').show();
					$('#formelement-CDN_TYPE').change();
				}
				else{
					$('.advanced').hide();
				}
		});

		$('#formelement-CDN_TYPE').change(function(){
			var v = $(this).val(), i;

			for(i in cdnopts){
				if(cdnopts[i].group == v){
					cdnopts[i].$wrapper.show();
				}
				else{
					cdnopts[i].$wrapper.hide();
				}
			}
		}).change();
		
		// Initial setting
		$('.advanced').hide();
	});
</script>
